/*
    кнопки запуска сценария 
    при любом нажатии на on/off пишем 1 в объект 
*/
$(function() {
    $.i18n.add('mosaic.script', {  
        "ru" : {
            ctitle : "Сценарий",
            title : "Заголовок",
            object : "Объект (запуск сценария)",
            status: "Статусный объект"
        }
    })

    Widget.script= Widget.extend({
        config : { 
            title :  $.tr('mosaic.script.ctitle', 'Script'),
            fields : {
                title : {
                    datatype : "string",
                    title : $.tr('mosaic.script.title', 'Title')
                }   
            },
            objects : {
                "object-1" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-1" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.status', '"On/Off Status Object')
                },
                "object-2" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-2" : {
                    datatype : dt.bool, 
                    title :  $.tr('mosaic.script.status', '"On/Off Status Object')
                },
                "object-3" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-3" : {
                    datatype : dt.bool, 
                    title :  $.tr('mosaic.script.status', '"On/Off Status Object')
                },
                "object-4" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-4" : {
                    datatype : dt.bool, 
                    title :  $.tr('mosaic.script.status', '"On/Off Status Object')
                },
                "object-5" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-5" : {
                    datatype : dt.bool, 
                    title :  $.tr('mosaic.script.status', '"On/Off Status Object')
                },
                "object-6" : {
                    datatype : dt.bool, 
                    title : $.tr('mosaic.script.object', 'On/Off Object')
                },
                "object-status-6" : {
                    datatype : dt.bool, 
                    title :  $.tr('mosaic.script.status', '"On/Off Status Object')
                },
            },
            settings : {}             
        },
        count : function() {
            var v = 0;  
            for (var i=1; i<=6; i++) 
                if (this.existsValue("object-"+i)) v++;
            return v;
        },
        status : function(i) {
            var value = false;
            var o = "object-"+i, s="object-status-"+i;
            if (this.existsValue(s)) value = this.getValue(s);
            else if (this.existsValue(o)) value = this.getValue(o);
            return value;
        },
        active : function() { 
            for (var i=1; i<=6; i++) 
                if (this.status(i)) return true;
            return false;
        },
        changeValue : function(name, value) { 
            for (var i=1; i<=6; i++) 
                if (name=="object-"+i && this.existsValue("object-status-"+i)) return;
            return this.trigger("changed_value");
        }
    })

    WidgetView.script = WidgetView.extend({
         width : 3, 
         height : 2,
         slider : false,
         widget : false,
         values : {},
         active : false,

         //изменение размера виджета в зависимости от количества кнопок 
         resize : function(render) { 
            var w = $(window).width(), c = this.model.count();
            var width=3, height=2;
            if (w<=800) { 
                if (c<=3) { 
                    width=c; height=1;
                }else if (c==4) { 
                    width=2, height=2;
                }
            }else if (c<5) w = 2; 

            if (this.width!==width || this.height!==height) {
                if (render) {
                    this.size(width, height);
                    this.classSize();
                }else { 
                    this.width = width; 
                    this.height = height;
                }
            }
         },
         classSize : function() { 
            var w = $(window).width(), c = this.model.count();
            var widget = $(".widget", this.el);
            if (c>1 && !widget.hasClass("middle")) widget.addClass("middle");            
            if (w<=800) { 
                if (this.height>1 && !widget.hasClass("large")) widget.addClass("large");
                else if (this.height==1 && widget.hasClass("large")) widget.removeClass("large");   
            }
         },

         init : function() { 
            this.resize(false);
            this.statusValues();
            this.listenTo(this.model, "changed_value", this.changed_value);
         },   

         
         statusValues : function() { 
            for (i=1; i<=6; i++)  this.values[i]=this.model.status(i);
            this.active = this.model.active();
         },

         changed_value : function() {
            this.statusValues();
            return this._value();
         },

         //обновление статусов на виджете
         _value : function() {
            var active = false; 
            var t = this;
            $("a.item-btn.disabled").removeClass('disabled');
            $("a.item-btn", this.el).each(function(){
                var i = $(this).data("i"),
                    v = t.values[i];
                if (v && !$(this).hasClass("item-btn_on")) $(this).addClass("item-btn_on");
                else if (!v && $(this).hasClass("item-btn_on")) $(this).removeClass("item-btn_on");
                if (v) t.active = true; 
            })
            var w = $(".widget", this.el);
            if (t.active && w.hasClass("widget_off")) w.removeClass("widget_off");
            else if (!t.active && !w.hasClass("widget_off")) w.addClass("widget_off");
         },

         //превью виджета, выводится в списке справа 
         preview: _.template(" \
            <div class=\"widget widget_btns script\"> \
                <div class=\"widget-title\"> \
                    <div class=\"txt\"><%=ctitle()%></div> \
                </div> \
                <div class=\"btns\"> \
                    <div class=\"btns-wrap\"> \
                        <a href=\"javascript:;\" class=\"item-btn item-btn_on\"> \
                            <span class=\"on\">ON</span> \
                        </a> \
                        <a href=\"javascript:;\" class=\"item-btn item-btn_off\"> \
                            <span class=\"off\">OFF</span> \
                        </a> \
                        <a href=\"javascript:;\" class=\"item-btn item-btn_on\"> \
                            <span class=\"on\">ON</span> \
                        </a> \
                    </div> \
                </div> \
            </div> \
        "),         

         //шаблон вывода виджета 
         template: _.template(" \
            <div class=\"widget w-switches widget_btns script\"> \
                <div class=\"widget-title\"> \
                    <div class=\"txt\"><%=title()%></div> \
                </div> \
                <div class=\"btns\"> \
                    <div class=\"btns-wrap\"> \
                        <% for (var i=1; i<=6; i++) { %> \
                            <% if (existsValue('object-'+i)) { %> \
                                <a href=\"javascript:;\" class=\"item-btn<%=(status(i)?' item-btn_on':'')%>\" data-i=\"<%=i%>\"> \
                                    <span class=\"on\">ON</span> \
                                    <span class=\"off\">OFF</span> \
                                </a> \
                            <%}%> \
                        <% } %> \
                    </div> \
                </div> \
            </div> \
        "),
         
         afterRender : function() {
            if (!this.model.isPreview) { 
                this.classSize();
                if (!this.model.active()) $(".widget", this.el).addClass("widget_off");
            }else  $(".widget", this.el).addClass("middle"); 
            var t = this;
            $(window).on('resize', function(){
                t.resize(true);
            });            
         },

         //события - клики по кнопкам 
        events : {
            "vclick a.item-btn" : function(e) {
                var b = $(e.currentTarget), i = b.data("i");
                e.preventDefault();
                if (b.hasClass("disabled")) return true; 
                b.addClass("disabled");
                this.model.write("object-"+i, 1);
                this.timeout_widget();
                var w = $(".widget", this.el);
            }
        },
        timeout : false,
        pause : 1000,
        timeout_widget : function() { 
            if (this.timeout) clearTimeout(this.timeout);
            var t = this;
            this.timeout = setTimeout(function() {return t.status(t)}, this.pause);         
        },
        status : function(t) { 
            this.statusValues();
            this._value();
            t.timeout = false;
        },
    })

})