/*
управление всем с colorpicker
*/
$(function() {
    $.i18n.add('mosaic.jscolor', {"ru" :{ ctitle:"Освещение (круговой диммер) c JS Color" } })

    Widget.jscolor = Widget.extend({
       	config : { 
            title : $.tr('mosaic.jscolor.ctitle', 'Lighting Controls'),
            fields : {
                title : {
                    datatype : "string",
                    title :  $.tr('mosaic.wtitle', 'Title')
                }
            },
            objects : {
                switch : {
                    datatype : 1, 
                    title : $.tr('mosaic.onoffobject', 'On/Off Object')
                },
                "switch-status" : {
                    datatype : 1, 
                    title : $.tr('mosaic.onoffstatusobject', 'On/Off Status Object')
                },
                luminosity : {
                    datatype : 5, 
                    title : $.tr('mosaic.dimmerobject', 'Dimmer Object')
                },
                "luminosity-status" : {
                    datatype : 5, 
                    title : $.tr('mosaic.dimmerstatusobject', 'Dimmer Status Object')
                },
                rgb : {
                    datatype : 232, 
                    title : $.tr('mosaic.colorobject', 'Color Object')
                },
                "rgb-status" : {
                    datatype : 232, 
                    title : $.tr('mosaic.colorstatusobject', 'Color Status Object')
                }
            },
            settings : {},
            systems:["lighting"]             
        },    
    	scaleStatus : function() {
            if (this.isPreview) return 30;
    		var value = 0, maxR = 255, o;
            
    		if (this.existsValue("luminosity-status")) o = this.getObject("luminosity-status"); 
    		else if (this.existsValue("luminosity")) o = this.getObject("luminosity");

            if (_.isObject(o)) { 
                if (o.datatype == 5001) maxR = 100;
                value = Math.round(o.value / maxR * 100); 
                if (value==0 && o.value>0) value = 1; 
                else if (value==100 && o.value<maxR) value=99;
            }

    		return value;
    	},
    	switchStatus : function() { 
    		var value = 1;
    		if (this.existsValue("switch-status")) {
    			if (!this.getValue("switch-status")) value =0;
    		}else if (this.existsValue("switch")) {
				if (!this.getValue("switch")) value =0;
			}else if (this.existsValue("luminosity-status")){
                if (this.getValue("luminosity-status")==0) value =0;
            }else if (this.existsValue("luminosity")){
                if (this.getValue("luminosity")==0) value =0;
            }
       		return value;
    	},
    	colorStatus : function() {
    		var value  = 2352366; 
    		if (this.existsValue("rgb-status")) value = this.getValue("rgb-status");
    		else if (this.existsValue("rgb")) value = this.getValue("rgb");
    		return value;
    	},
       	changeValue : function(name, value) {
       		if (name=="switch" && this.existsValue("switch-status")) return;
       		if (name=="luminosity" && this.existsValue("luminosity-status")) return;
       		if (name=="rgb" && this.existsValue("rgb-status")) return;
       		
       		if (name=="switch" || name=="switch-status") return this.trigger("changed_switch");
       		else if (name=="luminosity" || name=="luminosity-status") return this.trigger("changed_luminosity");
       		else if (name=="rgb" || name=="rgb-status") return this.trigger("changed_rgb");
       	},
       	changed_luminosity : function(v) {
            var o; 
            if (this.existsValue("luminosity")) o=this.getObject("luminosity");
            if (_.isObject(o)) { 
                var maxR=255; 
                if (o.datatype == 5001) maxR = 100;
                v = Math.round(v * maxR / 100);
                this.write("luminosity", v);
            }
       	}
    })

	WidgetView.jscolor = WidgetView.extend({
	     width : 3, 
	     height : 2,
	     slider : false, 
	     toggle : false, 
	     color : "666666",
	     switch : 0, 
	     luminosity :0,
	     slide : Date.now(),
         sliderColors : { 
            bg : {
                a:"#e4e4e4",
                u:""
            },
            cl : {
                a:"#8adfcf",
                u:"#d2d2d2"
            }
         },
         init : function() {
         	this.color = this.model.colorStatus().toString(16).toUpperCase();  
         	if (this.model.isPreview) this.color = "FF0000"; 
         	this.switch = this.model.switchStatus();
         	if (this.model.isPreview) this.switch = 1; 
         	this.luminosity = this.model.scaleStatus();
         	if (this.model.isPreview) this.luminosity = 60;
         	this.listenTo(this.model, "changed_switch", this.changed_switch);
         	this.listenTo(this.model, "changed_luminosity", this.changed_luminosity);
         	this.listenTo(this.model, "changed_rgb", this.changed_rgb);
         },	   
         changed_switch : function() {
         	if (this.timeout) return false; 
	      	this.switch = this.model.switchStatus();
         	this._switch();
         },
         changed_luminosity : function() { 
         	if (this.timeout) return false;
         	this.luminosity = this.model.scaleStatus();
         	this._luminosity();
         },
         changed_rgb : function() { 
         	this.color = this.model.colorStatus().toString(16).toUpperCase();  
         	this._color();
         },
         _switch : function() {
   			var w = $(".widget", this.el), isActive = this.switch==1;
			if (w.hasClass("widget_off") && isActive) {
                w.removeClass("widget_off");
                this.slider.trigger("configure", {
                    fgColor: this.sliderColors.cl.a,
                    inputColor: this.sliderColors.cl.a                    
                });
            }else if (!w.hasClass("widget_off") && !isActive)  {
                w.addClass("widget_off");
                this.slider.trigger("configure", {
                    fgColor: this.sliderColors.cl.u,
                    inputColor: this.sliderColors.cl.u                    
                });
            }   
			this.toggle.val(this.switch);      	
         },
         _color : function() { 
            var c = this.color;
            for (var i=c.length; i<6; i++) c="0"+c;
            $("a.change-color", this.el).css("background-color", "#"+c);
            if (this.picker) this.picker.fromString(c);
         },
         _luminosity : function() { 
            if (this.slider) {
             	var v = this.slider.val();
             	if (v!=this.luminosity) this.slider.val(this.luminosity).trigger("change");
            }
         },
	     template: _.template(" \
			<div class=\"widget js-widget widget_light widget_light_circular<%=(switchStatus()==0 && !isPreview?' widget_off':'')%>\">\
				<div class=\"widget-title\">\
					<div class=\"txt\"><%=title() || ctitle()%></div>\
				</div>\
				<% if (existsValue('switch') || isPreview) { %>\
					<div class=\"slider-toggle\"></div>\
				<% } %>\
				<% if (existsValue('luminosity') || isPreview) { %>\
	               <div class=\"slider-circular\" ><input disabled=\"1\" style=\"color:#8adfcf\"/></div>\
    			<% } %>\
				<% if (existsValue('rgb') || isPreview) { %>\
					<a href=\"javascript:;\" data-current-color=\"1\" data-current-id=\"1\" class=\"change-color\"></a>\
				<% } %>\
			</div>\
	     "),
	     events : {
	     	"vclick a.change-color" : function() { 
                console.log($("input.jscolor", this.$el).hasClass('jscolor-active'));
                if (!$("input.jscolor", this.$el).hasClass('jscolor-active'))
                    this.picker.show();
	     	}, 
	    	"change .slider-toggle" : function(e) {
	    		var v = this.toggle.val();
	    		if (v!==this.switch) { 
	    			this.switch = v;
	    			this.timeout_widget();
	    			this.model.write("switch", v==1);
	    			this._switch();  
	    		}
	    	},
	    	"vclick .slider-toggle" : function(e) {
	    		var t = $(e.target);
	    		if (!t.hasClass("noUi-base")) { 
	    			var v = this.toggle.val()==1 ? 0 : 1;
	    			this.toggle.val(v);
	    			this.toggle.trigger("change");
	    		} 
	    	},
            "change input.jscolor" : function (e){
                var c = $(e.currentTarget).val();
                if (c!=this.color){ 
                    this.color = c; 
                    this.timeout_widget();
                    this.model.write("rgb", parseInt(c, 16));
                    this._color();  
                }
            }
	     },
         change_circular : function(v) { 
            if (v!=this.luminosity) {
                this.timeout_widget();
                this.luminosity = v; 
                this.model.changed_luminosity(v);
                this._luminosity();
                var s = v>0 ? 1 : 0; 
                if (s!=this.switch) { 
                    this.switch=s; 
                    this._switch();
                }
            }
         },
         afterRender : function() {
         	this.toggle = $(".slider-toggle", this.el); 
            this.toggle.noUiSlider({ 
                start: this.switch, 
                range: {
                    min: [ 0, 1 ],
                    max: 1
                },
                format: wNumb({
                    decimals: 0
                })

            });
            var t = this;
            this.slider = $(".slider-circular input", this.el);
            if (this.slider.length>0) 
                this.slider = this.slider.eq(0);
            else 
                this.slider = false; 
            if (this.slider) { 
                var w = $(".widget", this.el);
                var active = !w.hasClass("widget_off");
                this.slider.knob({
                    thickness: .12,
                    width: 120,
                    height: 120,
                    min: 0,
                    max: 100,
                    angleOffset: 200,
                    angleArc: 320,
                    displayInput: true,
                    inputColor: active ?  t.sliderColors.cl.a : t.sliderColors.cl.u,
                    font: "normal 14px/1.4285 'Open Sans', Arial, 'Helvetica CY', 'Nimbus Sans L', sans-serif;",
                    bgColor:  t.sliderColors.bg.a, 
                    fgColor: active ?  t.sliderColors.cl.a : t.sliderColors.cl.u,
                    change: function(v) {
                        if (Date.now()-t.slide>200) { 
                            t.slide = Date.now();    
                            t.change_circular(Math.round(v)); 
                        }
                    },
                   release: function(v) {
                        t.change_circular(Math.round(v));
                    }                    
                });
                this.slider.val(this.luminosity).trigger("change");
            }
            if (this.model.existsValue('rgb')) {
                var input = document.createElement('INPUT');
                this.picker = new jscolor(input, {width: 260,  shadow:false, height:120});
                $(input).addClass("jscolor").insertAfter($("[data-current-color]", this.$el));  
                this._color();
            }
        },	 
        picker : false,
        timeout : false,
        pause : 2000,
		timeout_widget : function() { 
			if (this.timeout) clearTimeout(this.timeout);
			var t = this;
	        this.timeout = setTimeout(function() {return t.status(t)}, this.pause);			
		},
        status : function(t) { 
	      	this.color = this.model.colorStatus().toString(16).toUpperCase();  
         	t._color();
	      	this.switch = this.model.switchStatus();  
         	t._switch();
	      	this.luminosity = this.model.scaleStatus();
         	t._luminosity();
         	t.timeout = false;
        }             
	})
})
